"""
  Perewod formul mevdu SGSE i SI.
  Obozn.:
- 'l_', 'F_' etc. - zna`eniq w SGSE; na bumage rekomend. obozna`atx [trihom;
- 'l', 'F' etc. - zna`eniq w SI;
- 'p_l', 'p_F' etc. - perewodn. mnov.;
  traktowka: l_ (sm) = l (m) * p_l (sm/m), pri`@m p_l = 100 sm/m.
  Teku]. sost.:
- Porovdaet perehodn. mnoviteli mevdu wwodimymi weli`inami,
  ishodq iz ih opredelenij (tipa: 1000000/c ~= 1/300 ed_SGSE_U/Wolxt).
- Uspe[no obrabatywaet prostye f-ly po tipu
  plot_E_ = E_**2/(8*pi) <-> plot_E = E**2*eps0/2 .
- Pozwolqet prowerqtx razmernosti `astej formul.
  Nedostatki:
- Ne najdeno udowl. sposoba postoqnno sleditx za balansom
  razmernosti, po\tomu bylo re[eno razre[itx zameny s
  poterej razm-sti (tipa mu0 (razmern.) -> 4*pi*1e-7 (bezrazm.))
  w nadevde, `to pri naru[eniqh razm-sti polxzowatelx 
  ih zametit i dopolnitelxnymi zamenami w 'preob_flu'
  skompensiruet.  
"""
from sympy import *

otlad=False

def set_otlad(otlad_):
 global otlad
 otlad=otlad_

def R(r):
 """
 Obr.: R(1e7) ili R(1e-7); 
 ne rass`itano na R(2e-7) etc. - nado pisatx S(2)*R(1e-7) !!!
 """
 assert r>0.
 if r>=1.: p=S(int(r))
 else:     p=Rational(1,int(1./r))
 return(p)

SGSE_vars=[] # [l_, m_, ]
SGSE_nazw={} # {l_:'sm', B_:'Gs', }
SGSE_razm={} # {l_:sm, }
SI_vars=[]   # [l, m, ]
SI_nazw={}   # {l:'m', B:'Tl'}
SI_razm={}   # {l:metr, }
konst=[]       # [c_, c, ]
konst_znac={}  # {c_:2.9979e10, c:2.9979e8, }
konst_razm={}  # {c_:sm/sek, c:metr/sek, }
psewd=[]       # [mu0, eps0, ]
psewd_znac={}  # {mu0:4.0e-7*pi, eps0:2500000/(pi*c**2), }
psewd_razm={}  # {mu0:kg*metr/(Amper**2*sek**2), eps0:Amper**2*sek**4/(kg*metr**3), }
koefty_keys=[]; # [p_l, ]
koefty={}       # {p_l:100, p_q:10*c, }
koefty_razm={}  # {p_l:sm/m, }
SGSE_SI_keys=[]; SGSE_SI={} # {l_:l*p_l}
SI_SGSE_keys=[]; SI_SGSE={} # {l:l_/p_l}

def show_alle():
 print '--------\\'
 print 'SGSE_vars   SGSE_nazw   SGSE_razm:'
 for x in SGSE_vars: print '%-12s %-12s %-12s' % (x,repr(SGSE_nazw[x]),SGSE_razm[x])
 print '-'*4
 print 'SI_vars   SI_nazw    SI_razm:'
 for x in SI_vars: print '%-12s %-12s %-12s' % (x,repr(SI_nazw[x]),SI_razm[x])
 print '-'*4
 print 'konst        konst_znac   konst_razm:'
 for x in konst: print '%-12s %12.6g %-12s' % (x,konst_znac[x],konst_razm[x])
 print '-'*4
 print 'psewd        psewd_znac   psewd_razm:'
 for x in psewd: print '%-12s %-12s %-12s' % (x,psewd_znac[x],psewd_razm[x])
 print '-'*4
 # print 'koefty_keys   koefty   koefty_razm:'
 # for p_x in koefty_keys: print '%-12s %-12s %-12s' % (p_x,koefty[p_x],koefty_razm[p_x])
 print 'koefty_keys  koefty      k_val    koefty_razm         k_val_obr:'
 for p_x in koefty_keys:
  k_val=koefty[p_x].subs(konst_znac); 
  k_val=k_val.subs(zame_mu0)
  k_val=k_val.subs({unity_mu0: 1})
  # print 'k_val=',k_val
  k_val_obr=1./k_val
  try:
   print '%-8s %-12s %9.4g %-40s %9.4g' % \
    (p_x,koefty[p_x],k_val,koefty_razm[p_x],k_val_obr)
  except:
   print (p_x,koefty[p_x],k_val,koefty_razm[p_x],k_val_obr)
 print '-'*4
 print 'SGSE_SI:'
 for x in SGSE_SI_keys: print '%-12s %-12s' % (x,SGSE_SI[x])
 print '-'*4
 print 'SI_SGSE:'
 for x in SI_SGSE_keys: print '%-12s %-12s' % (x,SI_SGSE[x])
 print '--------/'

def ww_sablon(s):
 """
 s="l" -> "l_,l,p_l=symbols('l_,l,p_l')".
 """
 s1=s+'_,'+s+',p_'+s         # -> l_,l,p_l
 s2=s1+"=symbols('"+s1+"')"  # -> l_,l,p_l=symbols('l_,l,p_l')
 exec(s2)
 s3='x_,x,p_x='+s1           # -> x_,x,p_x=l_,l,p_l
 exec(s3)
 SGSE_vars.append(x_); SGSE_nazw[x_]=None; SGSE_razm[x_]=None
 SI_vars.append(x);    SI_nazw[x]=None;    SI_razm[x]=None 
 koefty_keys.append(p_x); koefty[p_x]=None; koefty_razm[p_x]=None  
 SGSE_SI_keys.append(x_); SGSE_SI[x_]=x*p_x; 
 SI_SGSE_keys.append(x);  SI_SGSE[x]=x_/p_x; 
 return(x_,x,p_x)

def ww_perwicn(s, p=None,
  SGSE_nazw_=None, SGSE_razm_=None,  
  SI_nazw_=None, SI_razm_=None,  
  ):
 """
 s="l" -> "l_,l,p_l=symbols('l_,l,p_l')";
 p - perew. mnov., esli e]@ neizw. - None.
 """
 if otlad: print '--\\'
 print 'ww_perwicn:',s,p
 x_,x,p_x = ww_sablon(s)
 SGSE_nazw[x_]=SGSE_nazw_
 SGSE_razm[x_]=SGSE_razm_
 SI_nazw[x]=SI_nazw_
 SI_razm[x]=SI_razm_
 koefty[p_x]=p; 
 koefty_razm[p_x]=SGSE_razm[x_]/SI_razm[x]  
 if otlad: print '--/'
 return(x_,x,p_x) 

def opred(
  s,
  left1,right1,left2,right2,  
  SGSE_nazw_=None, SI_nazw_=None
  ):
 """
 Obr. po tipu: opred('F',  X_,m_*a_, X,m*a, 'Din', 'Newton').
 """
 if otlad: print '--------\\'
 print 'opred:',s  # ,left1,right1,left2,right2
 x_,x,p_x=ww_sablon(s); 
 zz={X_:x_, X:x}
 left1=left1.subs(zz); right1=right1.subs(zz); 
 left2=left2.subs(zz); right2=right2.subs(zz); 
 otn1=left1/right1; 
 if otlad: print 'otn1=',otn1
 otn2=left2/right2; 
 if otlad: print 'otn2=',otn2
 otn=otn1/otn2            # l*t_*v_/(l_*t*v)
 if otlad: print 'opred: otn=',otn
 otn=otn.subs(SGSE_SI)    # p_t*p_v/p_l
 if otlad: print 'opred: subs(SGSE_SI) -> otn=',otn
 xx=solve(otn-1,p_x)[-1] # p_l/p_t; [-1] - na slu`aj [-sqrt(), sqrt()].
 if otlad: print 'opred: solve -> xx=',xx
 # Dlq ww. D=eps0*E woznik. eps0 - nado izbaw. ot ne@;
 # pri \tom zamena `erez c**2 -> obrab. ne do konca,
 # po\tomu prihoditsq wwesti zame_eps0_mu0.
 try:
  xx=xx.subs(zame_eps0_mu0) 
 except: 
  pass
 yy=xx.subs(koefty)       # 100
 if otlad: print 'opred: subs(koefty) -> yy=',yy
 koefty[p_x]=yy
 zz=xx.subs(koefty_razm)
 zz=zz.subs(konst_razm)
 zz=zz.subs(psewd_razm)
 if otlad: print 'opred: subs(*razm) -> zz=',zz
 koefty_razm[p_x]=zz

 SGSE_nazw[x_]=SGSE_nazw_
 SI_nazw[x]=SI_nazw_

 x1=solve(otn1-1,x_)[-1]; 
 if otlad: print x_,'=',x1  
 SGSE_razm_ = x1.subs(SGSE_razm)
 SGSE_razm_ = SGSE_razm_.subs(konst_razm)
 if otlad: print 'SGSE_razm_=',SGSE_razm_
 SGSE_razm[x_]=SGSE_razm_

 x2=solve(otn2-1,x)[-1]; 
 if otlad: print x,'=',x2
 SI_razm_ = x2.subs(SI_razm)
 SI_razm_ = SI_razm_.subs(konst_razm).subs(psewd_razm)
 if otlad: print 'SI_razm_=',SI_razm_
 SI_razm[x]=SI_razm_

 if otlad: print '--------/'
 return(x_,x,p_x)

def ubr_numbers(a):
 if len(a.args)==0: return(a); # T.e. \to simwol.
 b=S(1)
 for x in a.args:
  if otlad: print x,x.is_Number,x.is_number
  if not x.is_number: b*=x
 return(b)

def opr_razm(a):
 if otlad: print '----\\'
 if otlad: print 'opr_razm:'
 x=ubr_numbers(a)
 if otlad: print 'x=',x
 y=x.subs(konst_razm).subs(psewd_razm); 
 if otlad: print 'y=',y
 z=y.subs(SI_razm); 
 if otlad: print 'z=',z
 z=z.subs(SGSE_razm); 
 if otlad: print 'z=',z
 if otlad: print '----/'
 return(z)
 
def opr_razm2(bezrazm,treb,razmernosti):
 """
 Napr.,
 left2 = F/l;   right2 = mu0/(4*pi)*2*I**2/l
 razm_mu0 = opr_razm2(left2/right2,mu0,SI_razm)
 .
 razmernosti - SI_razm ili SGSE_razm.
 """
 print '----\\'
 print 'opr_razm2:',bezrazm,treb
 b=ubr_numbers(bezrazm)
 x = solve(b-1,treb)[-1]; 
 if otlad: print 'x=',x
 y=x.subs(konst_razm); 
 if otlad: print 'y=',y
 z=y.subs(razmernosti); 
 print 'z=',z
 print '----/'
 return(z)

def test_razm(a1,a2):
 b1=opr_razm(a1)
 b2=opr_razm(a2)
 rawn=b1==b2; 
 return(rawn,b1,b2)

def preob_flu(a1,a2,vari, napraw='SGSE_SI',
  dopoln_zame=[]):
 """
 Nedostatok zamysla: a1 movet bytx ne peremennoj, 
 a wyr-niem, no po zamyslu w preobr. f-le w lewoj
 `asti osta@tsq tk. 'vari'; t.o., dlq ur. Maksw.
 malo togo, `to wm. rot B_ = ... prid@tsq pisatx
 B_/l_ = ..., tak e]@ i posle preobr-niq polu`itsq
 B = ...*l . 
 Kak peredelatx - poka neqsno, tak `to re[eno poka `to 
 miritxsq s \tim. 
 """
 print '--------\\'
 print 'preob_flu:',a1,'=',a2  # mm_ = I_*l_**2/c_
 rawn,b1,b2=test_razm(a1,a2)
 try:
  assert rawn
 except:
  print 'Ne sowp. razmernosti !!!'
  print a1,'->',b1
  print a2,'->',b2
  raise
 if   vari in SI_vars:   napraw='SGSE_SI'
 elif vari in SGSE_vars: napraw='SI_SGSE'
 else: raise ValueError('vari='+str(vari)+' !!!')
 if otlad: print 'napraw=',napraw
 otn=a1/a2  # =1
 if otlad: print 'otn=',otn        # c_*mm_/(I_*l_**2)  ili  mm/(I*l**2) 
 if napraw=='SI_SGSE':
  otn=otn.subs(SI_SGSE); # print otn  # mm_*p_I*p_l**2/(I_*l_**2*p_mm)
  if otlad: print 'SI_SGSE -> otn=',otn  # c*mm*p_mm*p_v/(I*l**2*p_I*p_l**2)
  otn=otn.subs(zame_eps0)
  otn=otn.subs(zame_mu0)
  otn=otn.subs({unity_mu0: 1})
  if otlad: print 'ubr. eps0 i mu0 -> otn=',otn 
  otn=otn.subs(koefty)  # Movet wozniknutx 100*c ili mu0.
  if otlad: print 'koefty -> otn=',otn  
  otn=otn.subs(SI_SGSE) # 100*c -> c_ 
  otn=otn.subs(zame_mu0)
  otn=otn.subs({unity_mu0: 1})
  otn=otn.subs(koefty)  # 
 else: # SGSE_SI
  otn=otn.subs(SGSE_SI); 
  if otlad: print 'SGSE_SI -> otn=',otn  # c*mm*p_mm*p_v/(I*l**2*p_I*p_l**2)
  otn=otn.subs(koefty)
  if otlad: print 'koefty -> otn=',otn  # 
  otn=otn.subs(SGSE_SI); 
  if otlad: print 'SGSE_SI -> otn=',otn  # 

 try:
  xx=solve(otn-1,vari)[0] 
 except:
  print "Err. pri popytke 'solve' !!!"
  print 'otn=',otn
  print 'vari=',vari
  raise

 if otlad: print 'solve -> xx=',xx

 for zame in dopoln_zame:  # Napr., zame_c2 . 
  xx=xx.subs(zame)
  if otlad: print 'zame -> xx=',xx
  
 # Bez xx.args -> l**3/2, i ne o`ew., `to \to (l**3)/2.
 print vari,'=',xx       # mm = I*l**2
 if otlad: print xx.func,xx.args 
 print '--------/'
 return(vari,xx)

def export_wspomo(x):
 s=str(x)  # l
 s1=s+'_,'+s+',p_'+s         # -> l_,l,p_l
 s2=s1+"=symbols('"+s1+"')"  # -> l_,l,p_l=symbols('l_,l,p_l')
 print s2

def export_gotow():
 """
 Zamysel - wywesti gotowye tablicy, `toby ne stroitx 
 ih zanowo. Nedostatok: polu`. 1000000 wmesto S(1000000),
 t.e. polu`ennye tablicy nado dodelywatx wru`nu;, `to o`enx 
 trudo@mko. Krome togo, pri wyw. po 'print' w slowarqh 
 porqdok kl;`ej - udobnyj dlq s-my, a ne dlq `eloweka.
 """
 for x in SI_vars: export_wspomo(x)
 for x in konst: export_wspomo(x)
 for x in psewd: export_wspomo(x)
 print 'SGSE_vars=',SGSE_vars   
 print 'SGSE_nazw=',SGSE_nazw   
 print 'SGSE_razm=',SGSE_razm   
 print 'SI_vars=',SI_vars   
 print 'SI_nazw=',SI_nazw   
 print 'SI_razm=',SI_razm   
 print 'konst=',konst        
 print 'konst_znac=',konst_znac   
 print 'konst_razm=',konst_razm
 print 'psewd=',psewd
 print 'psewd_znac=',psewd_znac   
 print 'psewd_razm=',psewd_razm
 print 'koefty_keys=',koefty_keys   
 print 'koefty=',koefty   
 print 'koefty_razm=',koefty_razm
 print 'SGSE_SI=',SGSE_SI
 print 'SI_SGSE=',SI_SGSE

# --------

sm,g,sek = symbols('sm,g,sek', positive=True)
metr,kg,Amper = symbols('metr,kg,Amper', positive=True) # sek - uve wwedena.
X_,X=symbols('X_,X') # Wspomog. dlq opr. nowyh weli`in.

# Bezrazm. otnosit. udlinenie pri magnitostrikcii.
lam_,lam,p_lam=ww_perwicn('lam',S(1), None,S(1), None,S(1))

l_,l,p_l=ww_perwicn('l',S(100), 'sm',sm, 'metr',metr)
m_,m,p_m=ww_perwicn('m',S(1000),'gramm',g, 'kg',kg)
t_,t,p_t=ww_perwicn('t',S(1),'sek',sek, 'sek',sek)

Plo_,Plo,p_Plo=opred('Plo', X_,l_**2, X,l**2, None, None)
V_,V,p_V=      opred('V',   X_,l_**3, X,l**3, None, None)
nu_,nu,p_nu=   opred('nu',  X_,1/t_,  X,1/t,  'Gc', 'Gc')
v_,v,p_v=      opred('v',   X_,l_/t_, X,l/t,  None, None)
a_,a,p_a=      opred('a',   X_,v_/t_, X,v/t,  None, None)
F_,F,p_F=      opred('F',   X_,m_*a_, X,m*a, 'Din', 'Nxxton')
Ene_,Ene,p_Ene=opred('Ene', X_,F_*l_, X,F*l, 'Erg', 'Dvoulx')
Imp_,Imp,p_Imp=opred('Imp', X_,m_*v_, X,m*v,  None, None)
Dej_,Dej,p_Dej=opred('Dej', X_,Ene_*t_, X,Ene*t,  None, None)
# Natqvenie (= dawlenie).
sig_,sig,p_sig=opred('sig', X_,F_/Plo_, X,F/Plo, None, 'Paskalx')
# Plotnostx \nergii.
plot_E_,plot_E,p_plot_E =opred('plot_E', X_,Ene_/V_, X,Ene/V, None, None)
# Wekt. Pojntinga: Ene/t = S_Point*S => S_Po = Ene/(S*t)
S_Po_,S_Po,k_S_Po=opred('S_Po', X_,Ene_/(Plo_*t_), X,Ene/(Plo*t), None,None) 

# --------

c_,c=symbols('c_,c', positive=True)

konst.append(c_)
konst_znac[c_]=2.99792458e10
konst_razm[c_]=SGSE_razm[v_]
konst.append(c)
konst_znac[c]=konst_znac[c_]/koefty[p_v]
konst_razm[c]=SI_razm[v]
SGSE_SI_keys.append(c_); SGSE_SI[c_]=c*p_v; 
SI_SGSE_keys.append(c);  SI_SGSE[c]=c_/p_v; 

# --------

eps0,mu0=symbols('eps0,mu0', positive=True)
unity_mu0=symbols('unity_mu0', positive=True)
# unity_mu0 == edinica s razm-stx; mu0.

zame_mu0={mu0: S(4)*pi*R(1e-7)*unity_mu0}
zame_unity_mu0={unity_mu0: mu0/(S(4)*pi*R(1e-7))}

print 'Wwodim I.'

I_,I,p_I=ww_sablon('I');
SI_nazw[I]='Amper'
SI_razm[I]=Amper

print 'Poisk razm-stej I_ i p_I.'

left1 = F_/l_; right1 = S(2)*I_**2/(l_*c_**2)
left2 = F/l;   right2 = mu0/(4*pi)*2*I**2/l
SGSE_razm_I = opr_razm2(left1/right1,I_,SGSE_razm)
SGSE_razm[I_]=SGSE_razm_I
koefty_razm[p_I] = SGSE_razm[I_]/SI_razm[I]
print 'SGSE_razm[I_]=',SGSE_razm[I_]       # sqrt(g)*sm**(3/2)/sek**2
print 'SI_razm[I]=',SI_razm[I]             # Amper
print 'koefty_razm[p_I]=',koefty_razm[p_I] # sqrt(g)*sm**(3/2)/(Amper*sek**2)

print 'Analiz mu0.'

razm_mu0 = opr_razm2(left2/right2,mu0,SI_razm)
print 'razm_mu0=',razm_mu0  
# = kg*metr/(Amper**2*sek**2) = Nxxton/Amper^2.

psewd.append(mu0)
psewd_znac[mu0]=S(4)*pi*R(1e-7)
psewd_razm[mu0]=razm_mu0

zame_pi_mu0={pi: mu0/(S(4)*R(1e-7))}
# Napr., polu`. plot_E = pi*M_magn**2/2500000,
# a hotim polu`itx plot_E = M_magn**2*mu0 .

# Wwoditx q=I*t poka nelxzq, t.k. ne opr. p_I.
# Razm-stx p_I uve najdena; i]em `isl. zna`enie.
print 'Nah-nie p_I (ego razm-stx uve najdena).'

otn = (left1/right1)/(left2/right2) # F_*I**2*c_**2*mu0/(4*pi*F*I_**2)
otn=otn.subs(SGSE_SI)      # c**2*mu0*p_F*p_v**2/(4*pi*p_I**2)
otn=otn.subs(zame_mu0)  # c**2*p_F*p_v**2*unity_mu0/(10000000*p_I**2)
otn_razm=otn.subs(koefty_razm)
otn_razm=otn_razm.subs(konst_razm)  # 1/10000000, t.e. bezrazm.
otn_=otn.subs(koefty)  # Pri \tom razm-sti terq;tsq!
print 'otn_ =',otn_  # 100*c**2*unity_mu0/p_I**2
x=solve(otn_-1,p_I)[-1]     # 10*c*sqrt(unity_mu0)
x=x.subs({unity_mu0:S(1)})  # 10*c
print 'x=',x
koefty[p_I]=x

# --------

q_,q,p_q=opred('q', X_,I_*t_, X,I*t, None, 'Kulon')

# Polu`. p_I = p_q = 10*c; soglasuetsq s ovid.: 
# q_SI = 1.6021766208e-19, q_SGSE = 4.80320427e-10 ->
# q_SGSE/q_SI = 2.99792432847e9 = 10*c .

# --------

print 'Analiz eps0:'
left1 = F_; right1 = q_**2/l_**2
left2 = F;  right2 = (S(1)/(S(4)*pi*eps0))*q**2/l**2

razm_eps0 = opr_razm2(left2/right2,eps0,SI_razm)
print 'razm_eps0=',razm_eps0  
# -> Amper**2*sek**4/(kg*metr**3) == Kl^2/(N*m^2).

psewd.append(eps0)
psewd_znac[eps0]=None
psewd_razm[eps0]=razm_eps0
# konst.append(unity_mu0)
# konst_znac[unity_mu0]=S(1)
# konst_razm[unity_mu0]=razm_mu0

otn = (left1/right1)/(left2/right2) # F_*l_**2*q**2/(4*pi*F*eps0*l**2*q_**2)
otn=otn.subs(SGSE_SI)      # p_F*p_l**2/(4*pi*eps0*p_q**2)
otn_razm=otn.subs(koefty_razm)  # Amper**2*sek**4/(4*pi*eps0*kg*metr**3)
otn_razm=otn_razm.subs(konst_razm)  # 1/(4*pi), t.e. bezrazm.
print 'otn_razm=',otn_razm
otn_=otn.subs(koefty)  # Pri \tom razm-sti terq;tsq!
print 'otn_ =',otn_  # otn_ = 2500000/(pi*c**2*eps0)
x=solve(otn_-1,eps0)[-1]     # 2500000/(pi*c**2) = 1e7/(4*pi*c**2)
print 'x=',x
psewd_znac[eps0]=x

x=eps0*mu0; x=x.subs(psewd_znac); print 'eps0*mu0=',x  # c**(-2)
y=1/sqrt(x); print '1/sqrt(eps0*mu0)=',y  # c

zame_c2 = {c**2: S(2500000)/(pi*eps0)}
zame_eps0 = {eps0: S(2500000)/(pi*c**2)}
zame_eps0_mu0 = {eps0: S(1)/(mu0*c**2)}

# --------

"""
         SGSE:                                      SI: 
    Opr-nie \l. i magn. polej:
  F = q*E + q/c v x B .                       F = q*E + q v x B
      (P.190)                                   (F5.12)
     Opr. fi:
  E = - grad fi                               E = -grad fi
        (P.53)                               (F5.108)
     Opr. A:
  B = rot A                                   B = rot A
    (P.202)                                     (F5.277) 
"""

E_,E,p_E=   opred('E',  F_,q_*X_, F,q*X, None, None) # p_E=10000/c
B_,B,p_B=   opred('B',  F_,q_/c_*v_*X_, F,q*v*X, 'Gauss', 'Tesla') # 10000  
fi_,fi,p_fi=opred('fi', E_,X_/l_, E,X/l, None, 'Wolxt') # 1000000/c = 1/299.79 W/eq_SGSE_U
A_,A,p_A=   opred('A',  B_,X_/l_, B,X/l, None, None)  # 1000000

# |l. i magn. moment.
p_el_,p_el,p_p_el=opred('p_el', X_,Ene_/E_, X,Ene/E, None, None)
m_ma_,m_ma,p_m_ma=opred('m_ma', X_,Ene_/B_, X,Ene/B, None, None)

# |l. i magn. mom. ed-cy ob'@ma.
P_el_,P_el,p_P_el=opred('P_el', X_,p_el_/V_, X,p_el/V, None, None)
M_ma_,M_ma,p_M_ma=opred('M_ma', X_,m_ma_/V_, X,m_ma/V, None, None)

# Polq D i H.
D_,D,p_D=opred('D', X_,E_, X,eps0*E, None, None)
H_,H,p_H=opred('H', X_,B_, X,B/mu0, 'Ersted', 'A/m')

# Plotn. zarqda i plotn. toka.
rho_el_,rho_el,p_rho_el=opred('rho_el', X_,q_/V_, X,q/V, None, None)
j_,j,p_j = opred('j', X_,q_/(Plo_*t_), X,q/(Plo*t), None, None)

# Prowodimostx - sigma; ne putatx s wwed. ranee sig == dawl. ili natqv.!
# j = sigma*E => I = j*S, U = E*l, 
# R = U/I = E*l/*(j*S) = E*l/(sigma*E*S) = l/(sigma*S) -
# odinakowo w obeih s-mah.
sigma_,sigma,p_sigma=opred('sigma', X_,j_/E_, X,j/E, None, None)
R_,R,p_R=opred('R', X_,fi_/I_, X,fi/I, None, 'Om')

# &mkostx i ind-stx; L - opr. iz EDS = L*dI/dt.
C_,C,p_C=opred('C', X_,q_/fi_,    X,q/fi,   None, 'Farada')
L_,L,p_L=opred('L', X_,fi_*t_/I_, X,fi*t/I, None, 'Genri')

# --------

if __name__=='__main__':
 otlad=False
 show_alle()
 a1=plot_E_; a2=(S(1)/(S(8)*pi)) * E_**2 
 preob_flu(a1,a2,plot_E, dopoln_zame=[zame_c2])
 # -> plot_E = E**2*eps0/2 .
